package sqlite;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

public class Grupowanie {

	public static void main(String[] args) {
		final String sql = """
			SELECT job_id, job_title, count(employee_id), avg(salary), min(salary), max(salary)
			FROM jobs LEFT JOIN employees USING(job_id)
			GROUP BY job_id, job_title
			ORDER BY 3 DESC, 2;
		""";
		try(Connection c = DriverManager.getConnection("jdbc:sqlite:hr.db");
			PreparedStatement stmt = c.prepareStatement(sql);
			ResultSet rs = stmt.executeQuery()) {
			while(rs.next()) {
				// odczyt wg numerów kolumn, numeracja od 1
				System.out.printf("|%-10s| %-32s | %2d | %8.2f | %8.2f | %8.2f |%n",
						rs.getString(1),
						rs.getString(2),
						rs.getInt(3),
						rs.getBigDecimal(4),
						rs.getBigDecimal(5),
						rs.getBigDecimal(6));
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}

}
